package main

import "fmt"
import "net/http"
import "github.com/holizz/terrapin"
import "image"
import "image/png"
import "math"

/*
	go mod init NOMEMODULO    -> creare un go.mod banale
	go mod tidy               -> aggiungere e scaricare le dipendenze
	go build                  -> compila
*/

func quadratoFunc(w http.ResponseWriter, r *http.Request) {
	i := image.NewRGBA(image.Rect(0, 0, 900, 500))    // Creo campo

	t := terrapin.NewTerrapin(i, terrapin.Position{450.0, 250.0})
	for i := 0; i < 4; i++ {
		t.Forward(50)
		t.Right(math.Pi/2)
	}

	png.Encode(w, i)
}

func kochCurve(t *terrapin.Terrapin, lung float64, liv int) {
	if liv == 0 {
		t.Forward(lung)
	} else {
		kochCurve(t, lung, liv - 1)
		t.Left(math.Pi / 3)
		kochCurve(t, lung, liv - 1)
		t.Right(2 * math.Pi /3)
		kochCurve(t, lung, liv - 1)
		t.Left(math.Pi / 3)
		kochCurve(t, lung, liv - 1)
	}
}

func kochSnowflake(t *terrapin.Terrapin, lung float64, liv int) {
		for i := 0; i < 3; i++ {
			kochCurve(t, lung, liv)
			t.Right(2 * math.Pi / 3)
		}
}

func kochPage(w http.ResponseWriter, r *http.Request) {
	i := image.NewRGBA(image.Rect(0, 0, 900, 500))    // Creo campo

	t := terrapin.NewTerrapin(i, terrapin.Position{450.0, 350.0})

	kochSnowflake(t, 3.0, 4)

	png.Encode(w, i)
}

func main() {
	http.HandleFunc("/quadrato", quadratoFunc)
	http.HandleFunc("/kochpage", kochPage)

	fmt.Println("Listening on http://localhost:3000/")
	http.ListenAndServe(":3000", nil)
}